//   RW Curator
// ==============
// Search, Information, and Data Storage, Retrieval, & Optimizations Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/curator/curator.hpp
// -Declarations of the baseline RW Curator library

#pragma once

#include "incls_all.hpp"

namespace rw::curator {

//------------------------------------------------------------------------------
class Curator_b : public RW {
 public:
  Curator_b();                                    // default ctor
  explicit Curator_b(std::string const& handle);  // tag-parm'd ctor
};

//------------------------------------------------------------------------------
class Curator : public Curator_b {
 public:
  Curator();                                    // default ctor
  explicit Curator(std::string const& handle);  // tag-parm'd ctor

  inline auto dollhouse() const -> Dollhouse& { return dollhouse_; }

 private:
  unique_ptr<Dollhouse_b> _dollhouse_{
      make_unique<Dollhouse_b>("curator_dollhouse")};

  Dollhouse& dollhouse_{reference_to<Dollhouse>(_dollhouse_.get())};
};

}  // namespace rw::curator

//    --=^=--

// "______"

// rw_curator_lib.v211218
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
