//   RW Dollnet
// ==============
// External, Inter-Networking Library
// -Part of the RW Foundations suite of libraries

// Filename: ./include/dollhouse/net/dollnet.hpp
// -Declarations of the baseline RW Dollnet sub-library

#pragma once

///////
// Dolldrop/Dollnet is meant for network-enabled projects only
#if __has_include(<curl_easy.h>)

#include "incls_all.hpp"

#include "curl_easy.h"
#include "curl_form.h"
//
using curl::curl_easy;
using curl::curl_easy_exception;
using curl::curl_ios;

namespace rw::dollhouse::net {

class Dollnet : public RW_slave {
 public:
  Dollnet();                                    // default ctor
  explicit Dollnet(std::string const& handle);  // tag-parm'd ctor

  /** Attempts an external network connection to @a uri. If successful, the
   * connection's body stream for @a uri is saved out to disk file
   * ( ./dolldrops/anons_file ).
   * @param[in] tag the caller's @c Hip
   * @param[in] uri the URI to attempt a download connection to
   * @return any header stream data for @a uri, if present
   * @note: internally catches a specialization of @c std::runtime_error on
   * @b curl errors (but doesn't re-throw, currently)
   */
  auto dl_w_header(Hip const&         tag,  // guarded, for Master only
                   std::string const& uri) -> std::ostringstream;
};

}  // namespace rw::dollhouse::net

#endif  // __has_include(<curl_easy.h>)

//    --=^=--

// "This apartment has super-high bandwidth illegal even to large corporations?"

// rw_dollhouse_lib.v211218
// Copyright (2021)
// License MIT (Expat) https://opensource.org/licenses/MIT
